<?php	session_start(); ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html>
<head>
<link rel="stylesheet" type="text/css" href="styles/style.css" />
    <link rel="stylesheet" type="text/css" href="styles/results.css" />
    <link rel="stylesheet" type="text/css" href="styles/query.css" />
    <link rel="stylesheet" type="text/css" href="styles/atnf.css" />

    <meta http-equiv="Content-Type" content="text/html; charset=iso-8759-1" />
    <meta name="DC.Creator" lang="en" content="personalName=Whiting,Matthew" />
    <meta name="ATNF.Maintainer" content="contactName=Webmaster,the" />
    <meta name="DC.Titlepri" lang="en" content="The ATNF Pulsar Archive Searcher" />
    <meta name="DC.Title.alt" lang="en" content="" />
    <meta name="DC.Subject" lang="en" content="pulsar" />
    <meta name="DC.Description" lang="en" content="Search the observation data archives at the ATNF" />
    <meta name="DC.Date.created" scheme="ISO8601" content="2002-12-12" />
    <meta name="ATNF.Site" content="Marsfield" />
    <meta name="ATNF.AccessPermission" content="Public" />
    <meta name="ATNF.MetaVersion" content="1.0" />

    <script type="text/javascript" src="scripts/nodomws.js"></script>
    <script type="text/javascript" src="scripts/atnf-css-utils.js"></script>
    <script type="text/javascript" src="scripts/atnf-dom-utils.js"></script>
    <script type="text/javascript" src="scripts/results.js"></script>
    <script type="text/javascript">
    function submit_form()
{
  document.frmResults.submit();
}
</script>
</head>
<title>ATNF Pulsar Data Archive Query Results</title>
<?php include_once("header.html"); ?>

<body class="atoa">
<!-- Start Content -->

<?php
  // query.php
  // 
  // Performs the user's query on the database
  // Albert Teoh 15.11.2005
	
include_once("constants.php");
include_once("database.php");
include_once("utils.php");
include_once("date.php");
include_once("security.php");
include_once("print_tables.php");
define("PSR_SEARCH_RADIUS",0.5);

// Processes the form and queries the database on the given parameters
//echo "username = " . $_SESSION['username'] . " authcode = " . $_SESSION['auth_code'] . " <br>\n";
	
	
if ( !( (isset($_SESSION['username']) && isset($_SESSION['auth_code'])) &&
	$_SESSION['auth_code'] == OK)) {
		
  echo "<center>Your session has expired due to inactivity. Please <a href=\"index.php\">log in</a>.</center>\n";
  exit();
 }
	
// Clean out any old variables
init();
	
///////////////////////////
// Collect the form values

// List of request parameters to display
$params_in           = get_param('params', $HTTP_GET_VARS);	
	
// The current state. E.g cart or results
// Need to maintain this because other actions could be performed without changing state 
$state            = get_param('state', $HTTP_GET_VARS);
	
// The selected action to perform. E.g. add observations to cart, or view profile
$actions          = get_param('actions', $HTTP_GET_VARS);
	
// List of checked observations. Note: Not necessarily observations in the cart.
// Cart observations are stored in $cart_items variable
$selected_obs              = get_param('selected_obs', $HTTP_GET_VARS);
	
// A boolean value to indicate whether if the user wants to view cals as well
$cals             = get_param('cals', $HTTP_GET_VARS);
	
// an array mapping observation number (corresponding to the index in all_results) 
// to an array of matching cals
$obs_cals = array();
		
// Display cals within this many minutes of the observation
$cals_within_mins = get_param('cals_within_mins', $HTTP_GET_VARS);
	
// cart_items is an array of numbers that index to the list of 
// results in all_results
$cart_items          = $_SESSION['cart_items'];
	
	
// this holds all the query results of observations as an array of
// associative arrays. E.g.
// array ( 0 => ( pulsar_name => 'J0437-4715',
//                DM          => 10,
//                period      => 1
//              ),
//
//         1 => (pulsar_name => 'J0437-4715',
//                DM          => 27,
//                period      => 1.112
//              )
//       )
//
if (isset($_SESSION['results'])) {
  $all_results = $_SESSION['results'];
 }
	
	
// Other form parameters. Pretty self explanatory?
$pulsar_name      = trim(get_param('pulsar_name', $HTTP_GET_VARS));
$obs_mode         = trim(get_param('obs_mode', $HTTP_GET_VARS));
$data_type        = trim(get_param('data_type', $HTTP_GET_VARS));
$orderBy          = trim(get_param('orderBy', $HTTP_GET_VARS));
$orderDir         = trim(get_param('orderDir', $HTTP_GET_VARS));
$survey           = trim(get_param('survey', $HTTP_GET_VARS));
$rahour           = trim(get_param('rahour', $HTTP_GET_VARS));
$ramin            = trim(get_param('ramin', $HTTP_GET_VARS));
$rasec            = trim(get_param('rasec', $HTTP_GET_VARS));
$decdeg           = trim(get_param('decdeg', $HTTP_GET_VARS));
$decmin           = trim(get_param('decmin', $HTTP_GET_VARS));
$decsec           = trim(get_param('decsec', $HTTP_GET_VARS));
$radius           = trim(get_param('radius', $HTTP_GET_VARS));
$bandname         = trim(get_param('bandname', $HTTP_GET_VARS));
$from_day         = get_param('from_day', $HTTP_GET_VARS);
$from_month       = get_param('from_month', $HTTP_GET_VARS);
$from_year        = get_param('from_year', $HTTP_GET_VARS);
$to_day           = get_param('to_day', $HTTP_GET_VARS);	
$to_month         = get_param('to_month', $HTTP_GET_VARS);
$to_year          = get_param('to_year', $HTTP_GET_VARS);
	
$startRange  = $HTTP_GET_VARS['startRange'];
$endRange = $HTTP_GET_VARS['endRange'];	
	
$tar_file = "";

$raj = ($rahour + $ramin/60. + $rasec/3600.) * 15.;
$decj = abs($decdeg) + $decmin/60. + $decsec/3600.;
if($decdeg[0]=='-'){$decj *= -1.;}
$radius /= 60.; // put into degrees.

$params = array();
$params[0] = "distance";
for ($i=0; $i < count($params_in); $i++) {
  array_push($params,$params_in[$i]);
 }

$psrNameOK = ($pulsar_name != "");

///////////////////////
// Perform actions
//
// Precondition: The query has already been made, so the list of cals foreach observation
// has already been determined ($_SESSION['obs_cals']).
	
if (isset($actions) && $actions != "") {
  switch ($actions) {

  case DOWNLOAD_ALL_OBS_CALS:

    if (isset($cart_items) && isset($all_results)) {
      //echo "Download all<br>\n";
      $tar_file = tarObsCalFiles($cart_items, $all_results, $cals_within_mins);
      echo " <meta http-equiv=\"REFRESH\" content=\"0; URL=".WEB_DOWNLOADS_DIR."/$tar_file\">\n";
    }

    break;
				
  case DOWNLOAD_ALL_OBS:

    if (isset($cart_items) && isset($all_results)) {
      //echo "Download all<br>\n";
      $tar_file = tarObsFiles($cart_items, $all_results);
      echo " <meta http-equiv=\"REFRESH\" content=\"0; URL=".WEB_DOWNLOADS_DIR."/$tar_file\">\n";
    }

    break;
			
  case DOWNLOAD_ALL_CALS:

    if (isset($cart_items) && isset($all_results)) {
      //echo "Download all<br>\n";
      $tar_file = tarCalFiles($cart_items, $all_results, $cals_within_mins);
      echo " <meta http-equiv=\"REFRESH\" content=\"0; URL=".WEB_DOWNLOADS_DIR."/$tar_file\">\n";
    }

    break;
			
  case VIEW_PROFILES:
				
    if (isset($selected_obs) && isset($all_results)) {
					
      // redirect to the view_profile page and pass through the selected_obs and obs_cals arrays
      $_SESSION['selected_obs'] = $selected_obs;
      $_SESSION['display_cals'] = false;
					
      include_once("view_profiles.php");
      exit;
    }

    break;
			
  case VIEW_PROFILES_CALS:
				
    if (isset($selected_obs) && isset($all_results)) {
					
      // redirect to the view_profile page and pass through the selected_obs and obs_cals arrays
      $_SESSION['selected_obs'] = $selected_obs;
      $_SESSION['display_cals'] = true;
					
      include_once("view_profiles.php");
      exit;
    }

    break;
			
  case REMOVE_FROM_CART:
    if (isset($selected_obs)) {
      if ($actions == REMOVE_FROM_CART) {
	$cart_items = array_diff($cart_items, $selected_obs);
      }
    }
    break;

  case ADD_TO_CART:
    if (isset($selected_obs)) {
      foreach ($selected_obs as $ob) {
	if (!in_array($ob, $cart_items)) {
	  array_push($cart_items, $ob);
	}
      }
    }
    break;
  }
 }
	
if (!(isset($startRange) && isset($endRange))) {
		
  if ($HTTP_GET_VARS['submit_button'] == 'submit' || !(isset($_SESSION['start_range']) || isset($_SESSION['end_range']))) {
    $startRange = 1;
    $endRange = MAX_DISPLAY_ROWS;
  }
	
  else {
    $startRange = $_SESSION['start_range'];
    $endRange = $_SESSION['end_range'];
  }
		
 }
	
if (!isset($cart_items)) {
  $cart_items = array();
 }
	
$_SESSION['cart_items'] = $cart_items;
$_SESSION['start_range'] = $startRange;
$_SESSION['end_range'] = $endRange;
	

if (!isset($params) && !isset($_SESSION['results'])) {
  echo "No parameters were selected. Please select at least one.<br>\n";
  exit;
 }
	
if (!isset($_SESSION['results']) || $HTTP_GET_VARS['submit_button'] == 'submit') {
		
  /////////////////////////////////////////////////////
  // Form the parameter string in the SQL SELECT clause
  $parameters = $params_in[0];

  for ($i=1; $i < count($params_in); $i++) {
    $parameters .= ", " . $params_in[$i];
  }

  $parameters .= ",data_loc,file_size_bytes,concat(data_loc,'/',filename) as pathname";

  // remove any leading and trailing commas
  $parameters = trim($parameters, ",");


  ///////////////////////////////////////
  // Convert gregorian day to julian day
  //

  $from_mjd = cal_to_jd (CAL_GREGORIAN, $from_month,  $from_day, $from_year ) - 2400000.5;
  $to_mjd = cal_to_jd ( CAL_GREGORIAN, $to_month, $to_day, $to_year ) - 2400000.5;

  /////////////////////////////////////////
  // Check that the user hasn't queried for data younger than 18 months
  //
		
  if (!atnf_staff($_SESSION['username'])) {
    echo "from_mjd = $from_mjd and to_mjd = $to_mjd<br>\n";

    $today_mjd = cal_to_jd ( CAL_GREGORIAN, date("n"), date("j"), date("Y") ) - 2400000.5;
		
    if ($today_mjd - $from_mjd < 730) { // 2 * 365 days = 730 days
		
      echo "You're asking for data which has not aged past the 18 month proprietary period<br>\n";
      echo "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5; URL=index.php?actions=error\">\n";
      exit;
    }
		
    // Set the end mjd date to the 18 months prior to current date
    if ( $to_mjd > ($today_mjd - 730)) {
      $to_mjd = $today_mjd - 730;
    }
  }
		

  ///////////////////////////////
  // Set up the query string
  //

  $whereString = "";
  $selectString = "SELECT ";

  ///////////////////////////
  // Constraint on pulsar name
  //
  //  In this case, query on pulsar name and on pulsar position 
  //       -- obtain the latter from PSRCAT
  if ($pulsar_name) {

    // Check to see if the pulsar given is in the catalogue
    $command = PSRCAT." -nohead -nonumber -o short -c \"\" $pulsar_name";
    exec($command,$output);

    if($output[0]=="") { // Pulsar is present

      $commandPSR = PSRCAT." -nohead -nonumber -o short -c \"RAJD DECJD\" $pulsar_name";
      exec($commandPSR, $outputPSR);
      list($psr_rajd, $psr_decjd) = split("[ ]+", trim($outputPSR[0]));
            
      // Remove the leading J and B
      $output_psrname = ltrim($pulsar_name, "JBbj");

      $angsepStringPSR = "degrees( acos( cos(radians(rajd-$psr_rajd))*cos(radians(decjd))*cos(radians($psr_decjd))+sin(radians(decjd))*sin(radians($psr_decjd))) )";
      
      $whereString .= " AND ( (($angsepStringPSR - 0.25*(bmaj+bmin)) < ".PSR_SEARCH_RADIUS.") OR src_name LIKE '%$output_psrname' )";
      
      $selectString .= "$angsepStringPSR as distance, ";
      
    }
    else{
      $whereString .= "AND (1 = 0)"; // return nothing;
      $selectString .= "0 as distance, ";
      $pulsarNameOK = False;
    }


  } 
  else{// if ($radius) {
  ////////////////////////////
  // Constraint on boundary
  //  The pulsar name search takes precedence if both fields are filled in.

    $angsepString = "(degrees( acos( cos(radians(rajd-$raj))*cos(radians(decjd))*cos(radians($decj))+sin(radians(decjd))*sin(radians($decj))) ) )";
		  
    $whereString .= " AND (($angsepString - 0.25*(bmaj+bmin)) < $radius) ";
		  
    $selectString .= "$angsepString as distance, ";

  }

  $selectString .= $parameters;

  ////////////////////////////
  // Constraint on obs mode

  if ($obs_mode == "search") {
    $whereString .= " AND filename like '%.sf'";
  }
  else if($obs_mode == "timing"){
    $whereString .= " AND filename not like '%.sf'";
  }

  ////////////////////////////
  // Constraint on data type

  if ($data_type) {
    $whereString .= " AND data_type = '$data_type'";
  }

  ////////////////////////////
  // Constraint on survey

  if ($survey) {
    $whereString .= " AND survey = '$survey'";
  }

  //////////////////////
  // Constraint on MJD

  $whereString .= " AND (MJD < $to_mjd AND MJD > $from_mjd)";

  //////////////////////
  // Constraint on freq

  $bandString = "";
  for ($i=0; $i < count($bandname); $i++) {
    if($bandname[$i] = "70cm") $bandString .=" and (obsfreq<500.)";
    if($bandname[$i] = "50cm") $bandString .=" and (obsfreq>600. and obsfreq<700.)";
    if($bandname[$i] = "20cm") $bandString .=" and (obsfreq>1199.99 and obsfreq<1800.01)";
    if($bandname[$i] = "13cm") $bandString .=" and (obsfreq>1999.99 and obsfreq<2500.01)";
    if($bandname[$i] = "10cm") $bandString .=" and (obsfreq>2599.99 and obsfreq<3600.01)";
    if($bandname[$i] = "6cm")  $bandString .=" and (obsfreq>4499.99 and obsfreq<5100.01)";
    if($bandname[$i] = "5cm")  $bandString .=" and (obsfreq>5899.99 and obsfreq<6800.01)";
    if($bandname[$i] = "3cm")  $bandString .=" and (obsfreq>8099.99 and obsfreq<8600.01)";
    if($bandname[$i] = "1.3cm") $bandString .=" and (obsfreq>20999.99 and obsfreq<24000.01)";
  }
  for ($i=0; $i < count($bandname); $i++) {
    if($bandname[$i] = "anyBand") $bandString = "";
  }
  $whereString .= $bandString;
  ////////////////////////
  //  Ordering the results
  
  $orderString = " ORDER BY ";
  $orderString .= $orderBy . " " . $orderDir;

  // add other alternatives, in order of preference, if they haven't been selected first.
  if($orderBy!="distance") $orderString .= ",distance asc";
  if($orderBy!="filename") $orderString .= ",filename desc";
  if($orderBy!="date") $orderString .= ",date asc";
  if($orderBy!="obsfreq") $orderString .= ",obsfreq asc";


  ///////////////////////////////
  // Performing SQL query
  //

  $link = db_connect();

  // Remove any leading or trailing AND and OR
  $whereString = trim($whereString, " AND OR");

  $query = "( $selectString FROM s70 WHERE $whereString ) UNION ( $selectString FROM obs WHERE $whereString )";

  $query .= $orderString;

//    echo "$query<br>";

  $result = mysql_query($query) or die('Main Query failed: ' . mysql_error() . "\n". $query);

  $all_results = array();

//   $temp_num_results = mysql_num_rows($result);
//   echo "<br><br><br>$temp_num_results<br>\n";
//   return 0;

  while ($line = mysql_fetch_assoc($result)) {
    array_push($all_results, $line );
  }
		
  $_SESSION['results'] = $all_results;
	
  mysql_free_result($result);

  mysql_close($link);
	
 }
	
// Make a copy of it to pass to another function
$params_cpy = $params;

// Get the number of rows and report
$num_rows = count($all_results);
	
// Calculate the total size of observations cart
$total_cart_size_bytes = 0;
	
foreach ($cart_items as $row) {
  $total_cart_size_bytes += $all_results[$row]['file_size_bytes'];		
}
	
if ($state == 'cart') {
  $num_display_rows = count($cart_items);
 }
 else {
   $num_display_rows = $num_rows;
 }
	
if (!(isset($startRange) && isset($endRange))) {
  $startRange = 1;
		
		
  if ($endRange < MAX_DISPLAY_ROWS) {
    $endRange = $num_display_rows;
  }
  else {
    $endRange = MAX_DISPLAY_ROWS;
  }
 }
?>
<form action="<?php echo $PHP_SELF; ?>" method="GET" id="frmResults">
  <input type="hidden" name="startRange" value="<?php echo $startRange;?>">
  <input type="hidden" name="endRange" value="<?php echo $endRange;?>">


  <table class="top_menu" border="0" id="tabQueryResults">
  <?php 
  if ($state == 'cart') { 
    ?>
    <tr class="top_menu"><td class="top_menu_heading" colspan="4"><h2>Observations Cart</h2></td></tr>
    <?php 
  } 
  else if ($state == 'results') { 
    ?>
    <tr class="top_menu"><td class="top_menu_heading" colspan="4"><h2>Query Results</h2></td></tr>
      <?php 
   } 
?>

<tr class="top_menu"><td class="top_menu"  align="left" width="30%"><a class="top_menu" href="index.php?command=logout">Logout</a> | 
  <a class="top_menu" href="change_password.html?prev_page=<?php echo $PHP_SELF;?>">Change Password</a> |
  <a class="top_menu" href="index.php?actions=new_query">New Query</a>
  </td>
  <td class="top_menu" width="50%" align="center">
  Actions: <select name="actions">
  <?php 
  if ($state == 'cart') 
    { 
      if ($total_cart_size_bytes/1000000 < MAX_DOWNLOAD_MB) {
	echo "<option>".DOWNLOAD_ALL_OBS_CALS."</option>\n";
	echo "<option>".DOWNLOAD_ALL_OBS."</option>\n";
	echo "<option>".DOWNLOAD_ALL_CALS."</option>\n";
      }
      else {
	echo "<option disabled>Download limit ".MAX_DOWNLOAD_MB."MB exceeded</option>\n";
      }
      ?>
      </option>
      <option><?php echo REMOVE_FROM_CART; ?></option>
      </select>
      <input type="submit" value="Perform action">
      </td>
      <td class="top_menu" align="right"><b><?php echo count($cart_items); ?></b>
      Item/s (<?php printf("%.1f MB", $total_cart_size_bytes/1000000);?>)</td>
      <td class="top_menu" align="right" width="1%"><a href="<?php echo $PHP_SELF;?>?state=results&startRange=1&endRange=<?php echo MAX_DISPLAY_ROWS; ?>">
      <img alt="Revert to query results" border="0" title="Revert to query results" src="/images/table_30px_white.png"></img></a>
      </td>
      <?php 
    } 
  else 
    { ?>
      <option>
	<?php 
	echo ADD_TO_CART; 
      ?>
	</option>
	    <option>----- Profile Viewing Options -----</option>
	    <option><?php echo VIEW_PROFILES; ?></option>
						    <?php 
										  echo "cals = $cals<br>\n";
    if (isset($cals) && $cals != "") {
      echo "<option>".VIEW_PROFILES_CALS."</option>\n";
    }
    ?>
      
    </select>
    <input type="submit" value="Perform action">
	</td>
	<td class="top_menu" align="right" width="20%"><b><?php echo count($cart_items); ?></b>
	<a href="<?php echo $PHP_SELF;?>?state=cart&startRange=1&endRange=<?php echo count($cart_items);?>">Item/s</a> (<?php printf("%.1f MB", $total_cart_size_bytes/1000000);?>)</td>
	<td class=\"top_menu\" align=\"right\" width=\"1%\"><a href="<?php echo $PHP_SELF;?>?state=cart&startRange=1&endRange=<?php echo count($cart_items);?>">
    <img alt="View observation cart" border="0" title="View observation cart" src="/images/cart_30px_white.png"></img></a>
    </td>
<?php
  }
echo "</tr></table>\n";

if ($num_display_rows == 0) {
  if($state == "cart"){
    echo "<center>Your cart is empty.</center><br>\n";
    echo "<center><a href=\"";
    echo $PHP_SELF;
    echo "?state=results&startRange=1&endRange=";
    echo MAX_DISPLAY_ROWS;
    echo "\">Go back to search results</a></center><br>\n";
  }
  else {
    echo "<center>Sorry, no results matched your search</center><br>\n";
    if(!$pulsarNameOK && $pulsar_name!="") echo "<center>The pulsar name given, <b>$pulsar_name</b>, is not in the catalogue</center><br>\n";
    echo "<center><a href=\"index.php\">Search again</a></center><br>\n";
  }
  include "footer.html";
  echo "</body>\n</html>\n";
  exit();
 }

echo "<center>\n";
printNavigate($startRange, $num_display_rows);
echo "</center>\n";				
	
	
if ($num_display_rows < $endRange) {
  echo "Showing <b>$startRange - $num_display_rows</b> of <b>$num_display_rows</b> rows\n";
 }
 else {
   echo "Showing <b>$startRange - $endRange</b> of <b>$num_display_rows</b> rows\n";
 }
	
	
// TODO: Is this a better way to do it?
//if (mysql_data_seek($result, $startRange);

// Show first few
//print_r($all_results);
showTable($startRange-1, $endRange-1, $heading, $all_results, $params_cpy, $cals, $cals_within_mins);
	

echo "<center>\n";
printNavigate($startRange, $num_display_rows);
echo "</center>\n";
	
//echo "count all results = " . count($all_results);
	


?>
</form>
<?php include "footer.html"; ?>
</body>
</html>

